; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    .data
    align 16
    htbl \
      db "000102030405060708090A0B0C0D0E0F"
      db "101112131415161718191A1B1C1D1E1F"
      db "202122232425262728292A2B2C2D2E2F"
      db "303132333435363738393A3B3C3D3E3F"
      db "404142434445464748494A4B4C4D4E4F"
      db "505152535455565758595A5B5C5D5E5F"
      db "606162636465666768696A6B6C6D6E6F"
      db "707172737475767778797A7B7C7D7E7F"
      db "808182838485868788898A8B8C8D8E8F"
      db "909192939495969798999A9B9C9D9E9F"
      db "A0A1A2A3A4A5A6A7A8A9AAABACADAEAF"
      db "B0B1B2B3B4B5B6B7B8B9BABBBCBDBEBF"
      db "C0C1C2C3C4C5C6C7C8C9CACBCCCDCECF"
      db "D0D1D2D3D4D5D6D7D8D9DADBDCDDDEDF"
      db "E0E1E2E3E4E5E6E7E8E9EAEBECEDEEEF"
      db "F0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFF"

    .code

start:
   
; 

    call main
    exit

; 

main proc

    LOCAL hMem  :DWORD
    LOCAL hFile :DWORD
    LOCAL flen  :DWORD
    LOCAL mbuf  :DWORD
    LOCAL bw    :DWORD
    LOCAL rf    :DWORD
    LOCAL wrd   :WORD
    LOCAL pbuf  :DWORD

    LOCAL ptar  :DWORD


    LOCAL buffer[260]:BYTE
    LOCAL tbuffr[260]:BYTE

    mov pbuf, ptr$(buffer)
    mov ptar, ptr$(tbuffr)

    invoke GetCL,1,pbuf
    cmp eax, 1
    je nxt
    print "Invalid command line",13,10
    call help
    ret

  nxt:
    invoke GetCL,2,ptar
    cmp eax, 1
    je nxtx
    print "No target file specified",13,10
    call help
    ret

  nxtx:
    mov hMem, InputFile(pbuf)
    mov flen, ecx
    add ecx, ecx
    add ecx, flen
    mov mbuf, alloc(ecx)

    mov hFile, fcreate(ptar)

    fprint hFile,"    INTEGER hFile"        ; write the lead script commands
    fprint hFile,"    INTEGER rv"
    fprintc hFile,"\n    hFile = fcreate \qyourfile.ext\q\n\n"

    push ebx
    push esi
    push edi

    mov esi, hMem
    mov edi, flen
    add edi, esi
    sub edi, 1
    mov rf, edi
    xor ebx, ebx
    mov edi, mbuf

    mov DWORD PTR [edi], "    "
    add edi, 4
    mov DWORD PTR [edi], "= vr"
    add edi, 4
    mov DWORD PTR [edi], "ehf "
    add edi, 4
    mov DWORD PTR [edi], "tuox"
    add edi, 4
    mov DWORD PTR [edi], "iFh "
    add edi, 4
    mov DWORD PTR [edi], "  el"
    add edi, 3
    mov BYTE PTR [edi], 34
    add edi, 1

; ====================================

    sub esi, 1
  @@:
    add esi, 1
    movzx eax, BYTE PTR [esi]
    mov dx, WORD PTR [htbl+eax*2]
    mov WORD PTR [edi], dx
    add edi, 2

    add ebx, 1

    cmp ebx, 64
    jne nxt1

    mov BYTE PTR [edi], 34
    add edi, 1
    mov WORD PTR [edi], 0A0Dh
    add edi, 2
    mov DWORD PTR [edi], "    "
    add edi, 4
    mov DWORD PTR [edi], "= vr"
    add edi, 4
    mov DWORD PTR [edi], "ehf "
    add edi, 4
    mov DWORD PTR [edi], "tuox"
    add edi, 4
    mov DWORD PTR [edi], "iFh "
    add edi, 4
    mov DWORD PTR [edi], "  el"
    add edi, 3
    mov BYTE PTR [edi], 34
    add edi, 1

    xor ebx, ebx

  nxt1:
    cmp esi, rf
    jl @b

; ====================================

    cmp ebx, 64
    je nxt2

    mov BYTE PTR [edi], 34
    add edi, 1

  nxt2:
    sub edi, mbuf
    invoke WriteFile,hFile,mbuf,edi,ADDR bw,NULL    ; write the main hex data

    fprintc hFile,"\n\n    rv = fclose hFile\n\n"   ; write the tail script commands
    fprintc hFile,"    end\n"

    fclose hFile

    pop edi
    pop esi
    pop ebx

    free hMem
    free mbuf

    print "Done !",13,10

    ret

main endp

; 

help proc

    print "file2se.exe (c) 2006 hutch@movsd.com",13,10
    print "Convert any file to an SE script file",13,10,13,10
    print "SYNTAX : file2se sourcefile.ext targetfile.se",13,10

    ret

help endp

; 

end start
